'use client';
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import LinkUtility from './LinkUtility.js';
import withStateNavigator from './withStateNavigator.js';
var NavigationLink = function (props) {
    var htmlProps = LinkUtility.toHtmlProps(props);
    var stateKey = props.stateKey, navigationData = props.navigationData, includeCurrentData = props.includeCurrentData, currentDataKeys = props.currentDataKeys, hash = props.hash, stateNavigator = props.stateNavigator;
    var state = stateNavigator.stateContext.state;
    navigationData = LinkUtility.getData(stateNavigator, navigationData, includeCurrentData, currentDataKeys);
    try {
        var link = stateNavigator.getNavigationLink(stateKey, navigationData, hash);
    }
    catch (_a) { }
    htmlProps.href = link && stateNavigator.historyManager.getHref(link);
    htmlProps.onClick = link && LinkUtility.getOnClick(stateNavigator, props, link);
    var active = state && state.key === stateKey && LinkUtility.isActive(stateNavigator, navigationData);
    LinkUtility.setActive(active, props, htmlProps);
    return React.createElement("a", __assign({}, htmlProps));
};
export default withStateNavigator(NavigationLink);
