"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var navigation_1 = require("navigation");
var AsyncStateNavigator = /** @class */ (function (_super) {
    __extends(AsyncStateNavigator, _super);
    function AsyncStateNavigator(navigationHandler, stateNavigator, stateContext) {
        var _this = _super.call(this, stateNavigator, stateNavigator.historyManager) || this;
        _this.navigationHandler = navigationHandler;
        _this.stateNavigator = stateNavigator;
        _this.stateContext = stateContext;
        _this.configure = stateNavigator.configure.bind(stateNavigator);
        _this.onBeforeNavigate = stateNavigator.onBeforeNavigate.bind(stateNavigator);
        _this.offBeforeNavigate = stateNavigator.offBeforeNavigate.bind(stateNavigator);
        _this.onNavigate = stateNavigator.onNavigate.bind(stateNavigator);
        _this.offNavigate = stateNavigator.offNavigate.bind(stateNavigator);
        return _this;
    }
    AsyncStateNavigator.prototype.refresh = function (navigationData, historyAction) {
        var _this = this;
        var refreshData = __assign(__assign({}, this.stateContext.state.defaults), navigationData);
        var refreshKeys = Object.keys(refreshData);
        var equal = refreshKeys.length === Object.keys(this.stateContext.data).length;
        for (var i = 0; i < refreshKeys.length && equal; i++) {
            var key = refreshKeys[i];
            equal = equal && AsyncStateNavigator.areEqual(refreshData[key], this.stateContext.data[key]);
        }
        if (!equal)
            _super.prototype.refresh.call(this, navigationData, historyAction);
        else {
            var _a = this.stateContext, oldState_1 = _a.oldState, state_1 = _a.state, data_1 = _a.data, asyncData_1 = _a.asyncData;
            var startTransition = react_1.default.startTransition || (function (transition) { return transition(); });
            startTransition(function () {
                _this.navigationHandler.setState({ context: { ignoreCache: true, oldState: oldState_1, state: state_1, data: data_1, asyncData: asyncData_1, stateNavigator: _this } });
            });
        }
    };
    AsyncStateNavigator.areEqual = function (val, currentVal) {
        if (currentVal == null)
            return val == null || val === '';
        var valType = Object.prototype.toString.call(val);
        if (valType !== Object.prototype.toString.call(currentVal))
            return false;
        if (valType === '[object Array]') {
            var active = val.length === currentVal.length;
            for (var i = 0; active && i < val.length; i++) {
                active = this.areEqual(val[i], currentVal[i]);
            }
            return active;
        }
        else {
            return isNaN(val) ? val === currentVal : +val === +currentVal;
        }
    };
    AsyncStateNavigator.prototype.navigateLink = function (url, historyAction, history, suspendNavigation, currentContext) {
        var _this = this;
        if (historyAction === void 0) { historyAction = 'add'; }
        if (history === void 0) { history = false; }
        if (currentContext === void 0) { currentContext = this.stateContext; }
        if (!suspendNavigation)
            suspendNavigation = function (_stateContext, resumeNavigation) { return resumeNavigation(); };
        this.stateNavigator.navigateLink(url, historyAction, history, function (stateContext, resumeNavigation) {
            suspendNavigation(stateContext, function () {
                var asyncNavigator = new AsyncStateNavigator(_this.navigationHandler, _this.stateNavigator, stateContext);
                var _a = asyncNavigator.stateContext, oldState = _a.oldState, state = _a.state, data = _a.data, asyncData = _a.asyncData, history = _a.history;
                var startTransition = (!history && react_1.default.startTransition) || (function (transition) { return transition(); });
                startTransition(function () {
                    _this.navigationHandler.setState({ context: { oldState: oldState, state: state, data: data, asyncData: asyncData, stateNavigator: asyncNavigator } }, function () {
                        if (stateContext === _this.navigationHandler.state.context.stateNavigator.stateContext)
                            resumeNavigation();
                    });
                });
            });
        }, currentContext);
    };
    return AsyncStateNavigator;
}(navigation_1.StateNavigator));
exports.default = AsyncStateNavigator;
