"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var withStateNavigator_js_1 = __importDefault(require("./withStateNavigator.js"));
var ErrorBoundary = /** @class */ (function (_super) {
    __extends(ErrorBoundary, _super);
    function ErrorBoundary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { error: null, stateContext: null };
        return _this;
    }
    ErrorBoundary.getDerivedStateFromProps = function (_a, _b) {
        var stateContext = _a.stateNavigator.stateContext;
        var error = _b.error, errorContext = _b.stateContext;
        if (errorContext && errorContext !== stateContext)
            return { error: null, stateContext: null };
        return { stateContext: error ? stateContext : null };
    };
    ErrorBoundary.getDerivedStateFromError = function (error) {
        return { error: error };
    };
    ErrorBoundary.prototype.render = function () {
        var _a = this.props, errorFallback = _a.errorFallback, children = _a.children;
        var error = this.state.error;
        if (error) {
            if (!errorFallback)
                throw error;
            return typeof errorFallback !== 'function' ? (0, react_1.cloneElement)(errorFallback, { error: error }) : (0, react_1.createElement)(errorFallback, { error: error });
        }
        return children;
    };
    return ErrorBoundary;
}(react_1.Component));
exports.default = (0, withStateNavigator_js_1.default)(ErrorBoundary);
