"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var LinkUtility = /** @class */ (function () {
    function LinkUtility() {
    }
    LinkUtility.getData = function (stateNavigator, navigationData, includeCurrentData, currentDataKeys) {
        if (currentDataKeys || includeCurrentData) {
            var keys = typeof currentDataKeys === 'string' ? currentDataKeys.trim().split(/\s*,\s*/) : currentDataKeys;
            navigationData = stateNavigator.stateContext.includeCurrentData(navigationData, keys);
        }
        return navigationData;
    };
    LinkUtility.isActive = function (stateNavigator, navigationData) {
        var active = true;
        for (var key in navigationData) {
            var val = navigationData[key];
            active = active && (val == null || this.areEqual(val, stateNavigator.stateContext.data[key]));
        }
        return active;
    };
    LinkUtility.setActive = function (active, props, toProps) {
        if (active && props.activeStyle)
            toProps.style = __assign(__assign({}, toProps.style), props.activeStyle);
        if (active && props.activeCssClass)
            toProps.className = (!toProps.className ? '' : toProps.className + ' ') + props.activeCssClass;
        if (active && props.disableActive) {
            toProps.href = null;
            toProps.onClick = null;
        }
    };
    LinkUtility.areEqual = function (val, currentVal) {
        if (currentVal == null)
            return val == null || val === '';
        var valType = Object.prototype.toString.call(val);
        if (valType !== Object.prototype.toString.call(currentVal))
            return false;
        if (valType === '[object Array]') {
            var active = val.length === currentVal.length;
            for (var i = 0; active && i < val.length; i++) {
                active = this.areEqual(val[i], currentVal[i]);
            }
            return active;
        }
        else {
            return isNaN(val) ? val === currentVal : +val === +currentVal;
        }
    };
    LinkUtility.toHtmlProps = function (props) {
        var htmlProps = {};
        for (var key in props) {
            if (key !== 'stateNavigator' && key !== 'stateKey' && key !== 'navigationData'
                && key !== 'includeCurrentData' && key !== 'currentDataKeys' && key !== 'hash'
                && key !== 'activeStyle' && key !== 'activeCssClass' && key !== 'disableActive'
                && key !== 'distance' && key !== 'historyAction' && key !== 'navigating'
                && key !== 'navigate' && key !== 'withContext' && key !== 'startTransition')
                htmlProps[key] = props[key];
        }
        return htmlProps;
    };
    LinkUtility.getOnClick = function (stateNavigator, props, link) {
        return function (e) {
            if (!e.ctrlKey && !e.shiftKey && !e.metaKey && !e.altKey && !e.button) {
                var navigating = props.navigating, historyAction = props.historyAction, startTransition = props.startTransition;
                if (!navigating || navigating(e, link)) {
                    e.preventDefault();
                    startTransition = startTransition || react_1.default.startTransition || (function (transition) { return transition(); });
                    startTransition(function () {
                        stateNavigator.navigateLink(link, historyAction, false, undefined, undefined);
                    });
                }
            }
        };
    };
    return LinkUtility;
}());
exports.default = LinkUtility;
