'use client';
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var LinkUtility_js_1 = __importDefault(require("./LinkUtility.js"));
var withStateNavigator_js_1 = __importDefault(require("./withStateNavigator.js"));
var NavigationLink = function (props) {
    var htmlProps = LinkUtility_js_1.default.toHtmlProps(props);
    var stateKey = props.stateKey, navigationData = props.navigationData, includeCurrentData = props.includeCurrentData, currentDataKeys = props.currentDataKeys, hash = props.hash, stateNavigator = props.stateNavigator;
    var state = stateNavigator.stateContext.state;
    navigationData = LinkUtility_js_1.default.getData(stateNavigator, navigationData, includeCurrentData, currentDataKeys);
    try {
        var link = stateNavigator.getNavigationLink(stateKey, navigationData, hash);
    }
    catch (_a) { }
    htmlProps.href = link && stateNavigator.historyManager.getHref(link);
    htmlProps.onClick = link && LinkUtility_js_1.default.getOnClick(stateNavigator, props, link);
    var active = state && state.key === stateKey && LinkUtility_js_1.default.isActive(stateNavigator, navigationData);
    LinkUtility_js_1.default.setActive(active, props, htmlProps);
    return react_1.default.createElement("a", __assign({}, htmlProps));
};
exports.default = (0, withStateNavigator_js_1.default)(NavigationLink);
